#ifndef _LINUX_LCD_H
#define _LINUX_LCD_H

#define LCD_WRITE_DATA  1
#define LCD_READ_DATA   2
#define LCD_WRITE_CTRL  3
#define LCD_READ_CTRL   4
#define LCD_READ_PWSW   5
#define LCD_RESET_PWSW  6


#define LCD_B(minor)	lcd_table[(minor)].base		/* IO address */
#define LCD_F(minor)	lcd_table[(minor)].flags	/* flags for busy, etc. */
#define LCD_S(minor)	(lcd_table[(minor)].base + 1)	/* status port */
#define LCD_C(minor)	(lcd_table[(minor)].base + 2)	/* control port */
#define LCD_IRQ(minor)	lcd_table[(minor)].irq		/* interrupt # */
							/* 0 means polled */

#define LCD_BUSY        0x0001
#define LCD_EXIST       0x0002


#define LCD_DUMMY       0
#define LCD_INITVAL_C   0
#define LCD_INITVAL_D   0


struct lcd_struct {
	int base;
	unsigned int irq;
	int flags;
};

/*
 * This is the port delay time, in microseconds.
 * It is used only in the pio_init() and pio_reset() routine.
 */
#define LCD_DELAY 	50

/*
 * function prototypes
 */

extern int lcd_init(void);

#endif
