#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/ioctl.h>
#include <fcntl.h>
#include "lcd.h"

int
main()
{
    int  data, stat, ctrl;
    int  fd, d, ct, i,j;
    char c;
    char buff[256];

    fd = open( "/dev/lcd0", O_RDWR );
    if( fd < 0 ){
	fprintf( stderr, "file open error\n" );
	return -1;
    }

    /* LCD ȥꥻå */
    lcd_write_ctrl( fd, 0x30 );
    usleep( 4*1000 );

    lcd_write_ctrl( fd, 0x30 );
    usleep( 1000 );

    lcd_write_ctrl( fd, 0x30 );
    usleep( 1000 );

    lcd_write_ctrl( fd, 0x38 ); /* 8bit ⡼ɡ
				   2ɽ⡼,
				   5x8 ɥåȥեȤ */
    lcd_write_ctrl( fd, 0xe );  /* ǥץ쥤 ON,  ON,
				   ǤϤʤ */
    lcd_write_ctrl( fd, 0x6 );  /* ǡ쥸񤭹߻,
				   ɥ쥹󥿤򥤥󥯥 */
    lcd_write_ctrl( fd, 0x1 );  /* ̾õ */
    lcd_write_ctrl( fd, 0x2 );  /* ۡݥ */

    /* lcd driver Ȥ߹߻˾嵭ϢνԤΤǡǸ
       ̾õۡݥذưʳϡ
       ¹Ԥɬפ̵ */

    for( i=0; i< 0x10; ++i ){   
	lcd_write_data( fd, i + 0x60 );
    } /* ̤ˡ16 ʸɽ롣̾õ餳ޤǤƱƤϡ
	 write( fd, "\f`abcdefghijklmno", 17 );
	 Ǥ褤 */

    lcd_write_ctrl( fd, 0x2 );  /* ۡݥ */

    for( i=0; i< 0x10; ++i ){
	d = lcd_read_data( fd );
	printf( "0x%2.2x ", d );
    } /* ǡ쥸ɤ߹ߥƥȡºݤˤϤΤ褦ˡ񤭹
	 ʸɤɬפ뤫顩ǽȤƤΤǡ
	 Ǥ褦ˤʤäƤ롣 */
    printf( "\n" );

    lcd_reset_pwsw( fd );    /* Ÿܥ󤬲줿Ȥݻ뤿
				RS-FF ꥻåȤ롣 */

    while( lcd_read_pwsw( fd ) == 0 );  /* Ÿܥ󤬲ޤǥ롼פ */
    lcd_reset_pwsw( fd ); /* Ÿܥ RS-FF ꥻå */

    close( fd );
    return 0;
}

/* Ÿܥ󤬲ȡ RS-FF åȤ졢ioctl ȯԤ
RS-FF ꥻåȤ롣 ⤷Ÿܥ󤬲äѤʤäϡ
Ÿܥäޤ, ꥻåȤioctl ȯԤ³롣*/

int
lcd_reset_pwsw( int fd )
{
    int dummy;

    while( lcd_read_pwsw( fd ) ){
	ioctl( fd, LCD_RESET_PWSW, &dummy );
    }

    return 0;
}

/* Ÿܥ󤬲줿ɤ,å롣⤷Ÿܥ󤬲Ƥʤä
0 򤫤Ƥ 1 ֤ */

int
lcd_read_pwsw( int fd )
{
    int data;

    ioctl( fd, LCD_READ_PWSW, &data );

    return data;
}


/* 󥹥ȥ饯쥸˽񤭹ࡣܺ٤ϡHD44780 Υǡ
ȡ  */

int
lcd_write_ctrl( int fd, int data )
{
    ioctl( fd, LCD_WRITE_CTRL, &data );

    return 0;
}

/* ɥ쥹󥿤ȡӥե饰ɤ߹ࡣbit7 λӥ
bit0 ~ bit6 7bit ɥ쥹 */

int
lcd_read_ctrl( int fd )
{
    int data;

    ioctl( fd, LCD_READ_CTRL, &data );

    return data;
}

/* ǡ쥸ˡǡ񤭹ࡣ񤭹奢ɥ쥹󥿤ϥ󥯥
롣 ǡ쥸ؤν񤭹ߤ¿ϡwrite( fd, ... )  ǡ¸Τǡ
ޤȤɬפ̵Τʤ */

int
lcd_write_data( int fd, int data )
{
    ioctl( fd, LCD_WRITE_DATA, &data );

    return 0;
}


/* ǡ쥸ǡɤ߹, ɤ߹奢ɥ쥹󥿤ϥ󥯥
 */

int
lcd_read_data( int fd )
{
    int data;

    ioctl( fd, LCD_READ_DATA, &data );

    return data;
}
